''''''''''''''''''''''''''''''''''''''''''''''''''''''
' PDF2SMTP.vbs: PDF-Versand ber Ghostscript/SMTP
' von NKaczenski@ar-hannover.de (nils@kaczenski.de)
'
' nach Anregungen von Frank Carius (http://www.msxfaq.de/produkte/pdf2smtp.htm)
' und Wolfgang Reszel (http://www.rumborak.de/produktives/ghostscript/win2k/pdf.html)
' Idee fr den Workaround mit den Dateinamen (W2000) angeregt durch iX 03/2003
' wichtige Fundstellen auch:
' http://www.pstruh.cz/tips/detpg_binarytostring.htm
' http://www.pstruh.cz/tips/detpg_read-write-binary-files.htm
' http://www.microsoft.com/technet/scriptcenter/entscr/scrent16.asp
' http://msdn.microsoft.com/library/en-us/netdir/ad/example_code_for_searching_for_users.asp
'
' Version 0.8.07 vom 15. 7. 2003
' Erfolgreich getestet mit (Server-OS):
' Windows 2000 Professional, SP2
' Windows Server 2003
'
' Ohne Gewhr!
' Der Einsatz dieses Skripts geschieht vollstndig auf eigene Gefahr!
' Weder Nils Kaczenski noch Anders & Rodewyk bernehmen Support oder Gewhrleistung!
' Es werden keine Zusagen zu Funktionalitt oder Fehlerfreiheit gemacht!
''''''''''''''''''''''''''''''''''''''''''''''''''''''

debugmode = false
saydebug "Script gestartet"

' Variablen deklarieren
' Zahlen
dim intTitlePosLeft
dim intTitlePosRight

' ... Strings
dim strSMTPServer      ' DNS-Name des SMTP-Servers
dim strSMTPPort
dim strScriptPfad
dim strLogPfad
dim strLogDatei
dim strTitlePDF
dim strMethode
dim strPathPDF
dim strGSPfad
dim strGSArgs
dim strGSExec
dim strBodyText
dim strServerName

' ... Arrays
dim arrRedmon(8)

' ... Objekte
dim objFSO             ' Dateisystem
dim objLogDatei        ' die Logdatei
dim objTempFolder      ' der TEMP-Ordner
dim objEmail           ' ein CDO-Objekt
dim objSpooler
dim objArgs            ' An das Skript bergebene Argumente
dim objWSHShell        ' Die Shell
dim objWSHNetwork      ' Das Netzwerkobjekt

' ***!!! Diese Variablen ggf. anpassen !!!***
strSMTPServer = "mail.domain.local" ' DNS-Name des SMTP-Servers
strSMTPPort = "25" ' TCP/IP-Port des SMTP-Servers (Standard: 25)
strMailFrom = "pdf@domain.local" ' Absender der PDF-Mail
strGSPfad = "D:\PDF-Server\gs\gs7.22\bin\gswin32c.exe" ' Pfad zu GhostScript
strGSArgs = "-dNOPAUSE -dBATCH -sDEVICE=pdfwrite -dPDFSETTINGS=/default -dCompatibilityLevel=1.4 -sOutputFile="
strSpoolerDir = "d:\spooler" ' Spoolerverzeichnis
strPDFTemp = "D:\PDF-Server\temp" ' leer lassen, falls das System-Temp-Verzeichnis genutzt werden soll

' Sonstige
strScriptName = "PDF2SMTP"
strScriptVersion = "0.8.07"

' Statistik
strStartzeit = time

' Bentigte Objekte anlegen
set objArgs = WScript.Arguments
set objFSO = CreateObject("Scripting.FileSystemObject")
set objWSHShell = CreateObject("Wscript.Shell")
set objWSHNetwork = CreateObject("Wscript.Network")

if objArgs(0) = "" then
	wscript.echo "Keine Daten!"
	wscript.quit ' Keine Daten? Dann Schluss
end if

strServerName = objWSHNetwork.ComputerName

arrRedmon(0) = objWSHShell.ExpandEnvironmentStrings("%REDMON_PORT%")      ' der Port, z.B. SMTP1:
arrRedmon(1) = objWSHShell.ExpandEnvironmentStrings("%REDMON_JOB%")       ' Redmon-Jobnummer
arrRedmon(2) = objWSHShell.ExpandEnvironmentStrings("%REDMON_PRINTER%")   ' Redmon-Druckername
arrRedmon(3) = objWSHShell.ExpandEnvironmentStrings("%REDMON_MACHINE%")   ' auftraggebender Computer (UNC-Name)
arrRedmon(4) = objWSHShell.ExpandEnvironmentStrings("%REDMON_USER%")      ' auftraggebender User (SAM-Name)
arrRedmon(5) = objWSHShell.ExpandEnvironmentStrings("%REDMON_DOCNAME%")   ' Redmon-Auftragsname (Achtung, enthlt ein Komma!)
arrRedmon(6) = objWSHShell.ExpandEnvironmentStrings("%REDMON_FILENAME%")  ' ??? benutzt???
arrRedmon(7) = objWSHShell.ExpandEnvironmentStrings("%REDMON_SESSIONID%") ' Redmon-SessionID


' Dateioperationen
' Logdatei anlegen
strScriptPfad = WScript.ScriptFullName
strLogPfad = left(strScriptPfad, InstrRev(strScriptPfad, "\"))

with objFSO
	strLogDatei = "pdf2smtp.log"
	strLogDatei = .BuildPath(strLogPfad, strLogDatei)
	set objLogDatei = .OpenTextFile(strLogDatei, 8, true)
        if strPDFTemp = "" then
           set objTempFolder = .GetSpecialFolder(2)
        else
           set  objTempFolder = .GetFolder(strPDFTemp)
        end if
	set objSpooler = .GetFolder(strSpoolerDir)
end with

SchreibLog "--- Skript gestartet (" & strScriptName & ", " & strScriptVersion & ")"

' Debug-Info ausgeben
if debugmode then
   for i = 0 to UBound(arrRedmon)
       schreibLog i & ": " & arrRedmon(i)
   next
end if

strMailTo = ""
strMailTo = SAM2Mail(arrRedmon(4))
if isNull(strMailTo) then
   schreibLog "User: " & arrRedmon(4) & ": Keine Mailadresse verfgbar!"
   schreibLog "--- Abbruch"
   objLogDatei.Close
   wscript.quit
end if

SchreibLog "User: " & arrRedmon(4) & ", Mail: " & strMailTo
SchreibLog "User-Workstation: " & arrRedmon(3)

strTitlePDF = ""
strMethode = ""

' In manchen Umgebungen (z.B. W2000) gibt es Probleme mit dem bergebenen Dateinamen,
' daher hier verschiedene Methoden ...
if arrRedmon(5) <> arrRedmon(2) & ", Job " & arrRedmon(1) then
   strMethode = "Redmon-Angabe"
   strTitlePDF = arrRedmon(5)
   intPosDot = instrRev(strTitlePDF, ".")
   if intPosDot = 0 then intPosDot = len(strTitlePDF) + 1
   strTitlePDF = trim(left(strTitlePDF, intPosDot - 1)) & ".pdf"
else
   strMethode = "SHD-Auswertung"
   GetFileNameFromSHD
end if

' Falls der Name nicht gefunden wurde, gibt es hier einen Ersatznamen
if strTitlePDF = "" then
  strMethode = "Generierter Name"
  strTitlePDF = arrRedmon(4) & "-" & replace(arrRedmon(5), ",", "") & ".pdf"
end if

' verbotene Zeichen ersetzen - knnen z.B. beim Druck von Mails auftreten
strTitlePDF = replace(strTitlePDF, "\", "_")
strTitlePDF = replace(strTitlePDF, "/", "_")
strTitlePDF = replace(strTitlePDF, ":", "_")
strTitlePDF = replace(strTitlePDF, "*", "_")
strTitlePDF = replace(strTitlePDF, "?", "_")
strTitlePDF = replace(strTitlePDF, """", "_")
strTitlePDF = replace(strTitlePDF, "<", "_")
strTitlePDF = replace(strTitlePDF, ">", "_")
strTitlePDF = replace(strTitlePDF, "|", "_")
strTitlePDF = replace(strTitlePDF, "'", "_")
strTitlePDF = decURIsimple(strTitlePDF)  ' URI decodieren
strTitlePDF = replace(strTitlePDF, "%", "_")    ' das mag GhostScript nicht

' Kosmetik - die folgenden Passagen knnen ggf. gelscht werden ...
if left(strTitlePDF, 17) = "Microsoft Word - " then
  strTitlePDF = mid(strTitlePDF, 18) ' Word fgt sowas gern an - weg damit!
end if
if left(strTitlePDF, 23) = "Microsoft PowerPoint - " then
  strTitlePDF = mid(strTitlePDF, 24) ' PPT fgt sowas gern an - weg damit!
end if
if left(strTitlePDF, 6) = "Visio-" then
  strTitlePDF = mid(strTitlePDF, 7) ' Visio fgt sowas gern an - weg damit!
end if


if debugmode then
   schreibLog "bergebener Dateiname: " & arrRedmon(5)
   schreibLog "Ermittelter Dateiname: " & strTitlePDF
   schreibLog "Methode: " & strMethode
end if

strPathPDF = objFSO.BuildPath(objTempFolder.Path, strTitlePDF)
SchreibLog "Dateiname: " & strPathPDF

strGSExec = strGSPfad & " " & strGSARgs & """" & strPathPDF & """ """ & objArgs(0) & """"
schreibLog "GS-Befehl: " & strGSExec

' GhostScript aufrufen
strResult = objWSHShell.Run(strGSExec, 1, true)
if strResult <> 0 then
   schreibLog "GS-Ausfhrung beendet mit Fehlercode: " & strResult
   strBodyText = "Guten Tag!" & vbCrLf & vbCrLf
   strBodyText = strBodyText &  "Ihr Auftrag zum PDF-Ausdruck ist fehlgeschlagen." & vbCrLf & vbCrLf
   strBodyText = strBodyText &  "- Der Fehlercode von Ghostscript war: " & strResult & vbCrLf
   strBodyText = strBodyText &  "- Der erkannte PDF-Dateiname war: " & strTitlePDF & vbCrLf
   strBodyText = strBodyText &  "- Bitte berprfen Sie, ob evtl. der Dateiname ungltige Zeichen enthielt und versuchen Sie es ggf. noch einmal." & vbCrLf
   strBodyText = strBodyText &  "Sollte das Problem weiterhin auftreten, wenden Sie sich bitte an Ihren Support." & vbCrLf & vbCrLf
   strBodyText = strBodyText &  "- Skript: " & strScriptName & ", Version " & strScriptVersion & " am " & date & ", " & time & vbCrLf
   strBodyText = strBodyText &  "- PDF-Server: " & strServerName & ", Drucker: " & arrRedmon(2) & vbCrLf
   strBodyText = strBodyText &  vbCrLf & "Bitte antworten Sie nicht auf diese Mail." & vbCrLf
   strBodyText = strBodyText &  vbCrLf & "Ihr PDF2SMTP-Service" & vbCrLf

   sendMail false, "PDF-Ausdruck fehlgeschlagen!", strBodyText

else
   strBodyText = "Guten Tag!" & vbCrLf & vbCrLf
   strBodyText = strBodyText &  "Ihr konvertierter PDF-Ausdruck befindet sich im Anhang dieser Mail." & vbCrLf
   strBodyText = strBodyText &  "- Ausdruck erzeugt von " & arrRedmon(4) & " auf " & arrRedmon(3) & vbCrLf
   strBodyText = strBodyText &  "- PDF-Dateiname: " & strTitlePDF & vbCrLf
   strBodyText = strBodyText &  "- Erzeugt mit " & strScriptName & ", Version " & strScriptVersion & " am " & date & ", " & time & vbCrLf
   strBodyText = strBodyText &  "- PDF-Server: " & strServerName & ", Drucker: " & arrRedmon(2) & vbCrLf
   strBodyText = strBodyText &  "- Zeit zur Konvertierung: " & strStartzeit & " bis " & time & vbCrLf
   strBodyText = strBodyText &  vbCrLf & "Bitte antworten Sie nicht auf diese Mail, sondern wenden Sie sich ggf. an Ihren Support." & vbCrLf
   strBodyText = strBodyText &  vbCrLf & "Ihr PDF2SMTP-Service" & vbCrLf & vbCrLf

   sendMail true, "PDF-Ausdruck: " & strTitlePDF, strBodyText

end if


on error resume next
schreibLog "Aufrumen ..."
objFSO.deleteFile strBodyFilePfad
objFSO.deleteFile strPathPDF
checkit "Fehler beim Lschen der temporren Dateien!"
schreibLog "Aufrumen beendet."
on error goto 0

schreibLog "--- Skript beendet"
objLogDatei.Close

wscript.echo "Fertig."


function SAM2Mail(strSAMName)
    ' Funktion: bersetzt den bergebenen SAMAccountName per ADS-Abfrage in die SMTP-Adresse
    ' Eingabeparameter: strSAMName: Der NT-Anmeldename
    ' Rckgabewert: Die SMTP-Adresse oder ein Leerstring
    ' Kommentar:
    strField = "mail" ' Angabe des abzufragenden Feldes

    Dim objConn
    Dim objCommand
    dim objArgs

    On Error Resume Next


    'Create ADO connection object for Active Directory
    Set objConn = CreateObject("ADODB.Connection")
    objConn.Provider = "ADsDSOObject"
    objConn.Open "Active Directory Provider"
    if checkit("Fehler beim ADO-Zugriff auf Active Directory!") then exit function

    'Create ADO command object for the connection.
    Set objCommand = CreateObject("ADODB.Command")
    objCommand.ActiveConnection = objConn
    if checkit("Fehler beim Definieren des ADO-Kommandos!") then exit function


    'Get the ADsPath for the domain to search.
    Set objRoot = GetObject("LDAP://rootDSE")
    strDomain = objRoot.Get("defaultNamingContext")
    Set objDomain = GetObject("LDAP://" & strDomain)
    if checkit("Fehler beim Ansprechen des Active Directory!") then exit function

    'Abfrage
    strSQL = "SELECT " & strField & " FROM '"
    strSQL = strSQL & "LDAP://" & strDomain & "' WHERE sAMAccountName = '" & strSAMName & "'"

    'saydebug strSQL

    'Assemble the commandtext.
    objCommand.CommandText = strSQL
    if checkit("Fehler beim bergeben des Kommandos!") then exit function

    'Execute the query.
    Set objRS = objCommand.Execute
    if checkit("Fehler beim Ausfhren der Suche im Active Directory!") then exit function

    strOutput = ""
    strOutput = objRS.Fields(0).value

    on error goto 0

    SAM2Mail = strOutput

end function


sub sendMail(flgAttach, strSubject, strBody)
    ' Funktion: Message mit CDO versenden
    ' Eingabeparameter:
    ' Kommentar:

    on error resume next
    Set objEmail = CreateObject("CDO.Message")
    objEmail.From = strMailFrom
    objEmail.To = strMailTo
    objEmail.Subject = strSubject
    objEmail.Textbody = strBody
    if flgAttach = true then
       objEmail.AddAttachment strPathPDF
    end if
    objEmail.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/sendusing") = 2 ' SMTP-Server nicht lokal
    objEmail.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpserver") = strSMTPServer
    objEmail.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpserverport") = strSMTPPort
    objEmail.Configuration.Fields.Update
    objEmail.Send

    if not checkit("Fehler beim Senden der E-Mail!") then schreibLog "E-Mail '" & strSubject & "' erfolgreich gesandt."
    on error goto 0

end sub


sub GetFileNameFromSHD()
    ' Funktion:
    ' Eingabeparameter:
    ' Kommentar:
    ' Der folgende Abschnitt extrahiert den Original-Dateinamen
    ' aus der Shadow-Datei (SHD) im Spooler-Verzeichnis, um daraus
    ' den PDF-Namen zu machen. Dies ist ntig, weil unter W2000/XP
    ' der Original-Dateiname u.U. nicht bergeben wird.
    on error resume next

    ' Der Dateiname wird von RedMon generiert:
    ' Die Jobnummer mit fhrenden Nullen (fnfstellig)
    strSHD = arrRedmon(1) & ".SHD"
    strSHD = string ((5 - len(arrRedmon(1))), "0") & strSHD
    strSHDPfad = objFSO.BuildPath(objSpooler.Path, strSHD)
    ' gibt es diese Datei?
    schreibLog "Shadow-Datei: " & strSHDPfad & " existiert: " & objFSO.FileExists(strSHDPfad)

    if objFSO.FileExists(strSHDPfad) = true then
       ' Datei ist im Binrformat, daher konvertieren
       strSHD = BinaryToString(ReadBinaryFile(strSHDPfad))
       ' Jedes zweite Zeichen ist ASCII-0.
       ' Zum Vergleich muss daher der Suchstring "aufgenullt" werden
       for i = 1 to len(arrRedmon(4))
           strUserNameNulled = strUserNameNulled & mid(arrRedmon(4), i, 1) & chr(0)
       next
       ' Gegen Ende der Datei steht der Druckport mit Doppelpunkt (z.B. SMTP:).
       ' Direkt davor steht der Dateiname. Also finden wir den Doppelpunkt
       intPosColon = instrRev(strSHD, ":")
       ' Vor dem Dateinamen steht der Username, also suchen wir diese Stelle
       intPosLastUserName = instrRev(strSHD, strUserNameNulled, intPosColon)
       ' Und nun schneiden wir den String aus
       strOrigNameNulled = mid(strSHD, intPosLastUserName + len(strUserNameNulled), intPosColon - intPosLastUserName - len(strUsernameNulled))
       ' jetzt die Nullen entfernen
       strOrigName = replace(strOrigNameNulled, chr(0), "")
    
       ' Und nun entfernen wir alles nach dem letzten Punkt uns setzen dafr .pdf ein
       intPosDot = instrRev(strOrigName, ".")
       strTitlePDF = trim(left(strOrigName, intPosDot - 1)) & ".pdf"

       ' ... bis hier
    end if
    
    checkit "Fehler beim Extrahieren des Dateinamens!"
    on error goto 0
    ' hier endet das Extrahieren
end sub


Function BinaryToString(Binary)
  'Antonin Foller, http://www.pstruh.cz
  'Optimized version of a simple BinaryToString algorithm.

  Dim cl1, cl2, cl3, pl1, pl2, pl3
  Dim L
  cl1 = 1
  cl2 = 1
  cl3 = 1
  L = LenB(Binary)

  Do While cl1<=L
    pl3 = pl3 & Chr(AscB(MidB(Binary,cl1,1)))
    cl1 = cl1 + 1
    cl3 = cl3 + 1
    If cl3>300 Then
      pl2 = pl2 & pl3
      pl3 = ""
      cl3 = 1
      cl2 = cl2 + 1
      If cl2>200 Then
        pl1 = pl1 & pl2
        pl2 = ""
        cl2 = 1
      End If
    End If
  Loop
  BinaryToString = pl1 & pl2 & pl3
End Function



Function ReadBinaryFile(strFileName)
    ' Funktion: Liest eine Binrdatei ein
    ' Eingabeparameter: strFileName: Dateiname mit Pfad
    ' Rckgabewert: String mit dem Inhalt
    ' Kommentar: gefunden: http://www.pstruh.cz/tips/detpg_read-write-binary-files.htm
    Const adTypeBinary = 1

    'Create Stream object
    Dim objBinaryStream
    Set objBinaryStream = CreateObject("ADODB.Stream")

    'Specify stream type - we want To get binary data.
    objBinaryStream.Type = adTypeBinary

    'Open the stream
    objBinaryStream.Open

    'Load the file data from disk To stream object
    objBinaryStream.LoadFromFile strFileName

    'Open the stream And get binary data from the object
    ReadBinaryFile = objBinaryStream.Read
End Function


function decURIsimple(strTextLoc)
    ' Funktion: einfache Funktion zum Auflsen kodierter URLs. Nicht elegant, aber umschifft das Unicode-Problem, das die meisten anderen Funktionen nicht abdecken.
    ' Eingabeparameter:
    ' Kommentar:
    if instr(strTextLoc, "%") > 0 then
      strTextLoc = replace(strTextLoc, "%20", " ")
      strTextLoc = replace(strTextLoc, "%C3%BC", "")
      strTextLoc = replace(strTextLoc, "%C3%A4", "")
      strTextLoc = replace(strTextLoc, "%C3%B6", "")
      strTextLoc = replace(strTextLoc, "%C3%9C", "")
      strTextLoc = replace(strTextLoc, "%C3%84", "")
      strTextLoc = replace(strTextLoc, "%C3%96", "")
      strTextLoc = replace(strTextLoc, "%C3%9F", "")
    end if
    decURIsimple = strTextLoc

end function


' Fehlerprfung
function checkit(strNachricht)
	checkit = false
	if err.number <>0 then
		strNachricht = strNachricht & " [" & err.description & " (" & err.number & ")]"
                if ADSIerror then
                   Set objError = CreateObject("ADsError")
                   strKlartext = objError.GetErrorMessage(Err.number)
                   strNachricht = strNachricht & vbCrLf & "ADSI-Fehler: " & strKlartext & " (0x" & Hex(Err.number) & ")"
                end if
                sayerror strNachricht
		err.clear
		checkit=true
	end if
end function


' Universelle Ausgabefunktion
sub say(s)
	saynb s & vbCrLf
end sub

' Ausgabe ohne Zeilenumbruch
sub saynb(s)
	wscript.echo s
end sub

' Ausgabe als Fehlermeldung
sub sayerror(s)
	say "Fehler (" & date & ", " & time & "): " & s
	if not (objLogDatei = nothing) then schreibLog "Fehler: " & s
end sub

' Ausgabe als Warnung
sub sayalert(s)
	say "Warnung (" & date & ", " & time & "): " & s
end sub


' Debug-Ausgabe
sub saydebug(s)
	if debugmode then
		say s
	end if
end sub

' Logging
sub schreibLog(s)
    ' Funktion:
    ' Eingabeparameter:
    ' Kommentar:
    objLogDatei.writeLine date & ", " & time & ": " & s

end sub

